Miscellaneous bugfixes and enhancements for s390-tools 1.8.0 SLES11 SP1
backported from latest upstream s390-tools version 1.8.3:
* general: Fix compile warnings & do minor bugfixes
* general: Adjust code to s390-tools upstream as far as possible
* lsreipl: Show defined vmcmd correctly
* fdasd:   Fix auto mode behavior
---
 README                         |   48 -
 cpuplugd/man/cpuplugd.conf.5   |    3 
 dasdinfo/dasdinfo.c            |    4 
 dasdview/dasdview.c            |   75 +-
 dasdview/dasdview.h            |    5 
 etc/init.d/cpuplugd            |   15 
 etc/init.d/dumpconf            |    8 
 etc/init.d/mon_statd           |   25 
 fdasd/fdasd.c                  |   92 +-
 fdasd/fdasd.h                  |    2 
 include/zt_common.h            |    7 
 ip_watcher/Makefile            |    1 
 ip_watcher/start_hsnc.sh       |    5 
 ip_watcher/xcec-bridge.c       |    3 
 ipl_tools/ccw.c                |  110 +-
 ipl_tools/chreipl.h            |    3 
 ipl_tools/getopt.c             |   49 -
 ipl_tools/ipl.c                |    6 
 ipl_tools/main.c               |   22 
 ipl_tools/man/chreipl.8        |   10 
 ipl_tools/man/chshut.8         |    6 
 ipl_tools/man/lsreipl.8        |    4 
 ipl_tools/man/lsshut.8         |    2 
 ipl_tools/system.c             |   13 
 libu2s/u2s.c                   |    6 
 libvtoc/vtoc.c                 |    2 
 mon_tools/mon_fsstatd.c        |    7 
 mon_tools/mon_fsstatd.h        |    2 
 mon_tools/mon_procd.c          |   13 
 mon_tools/mon_procd.h          |    2 
 qethconf/qethconf.8            |    9 
 scripts/dbginfo.sh             |  100 ++
 scripts/scsi_logging_level     |    4 
 scripts/zfcpdbf                | 1517 ++++++++++++++---------------------------
 scripts/zfcpdbf.1              |   16 
 tape390/tape390_common.c       |    3 
 tape390/tape390_crypt.c        |   16 
 tape390/tape390_display.c      |    4 
 tunedasd/src/tunedasd.c        |    4 
 vmconvert/lkcd_dump.h          |    6 
 vmconvert/main.cpp             |    3 
 vmcp/vmcp.c                    |   12 
 vmur/vmur.cpp                  |   10 
 zconf/chccwdev                 |   44 -
 zconf/chccwdev.8               |    8 
 zconf/chchp                    |   12 
 zconf/chchp.8                  |    2 
 zconf/chzcrypt                 |    3 
 zconf/chzcrypt.8               |    3 
 zconf/lschp                    |    2 
 zconf/lscss                    |    9 
 zconf/lscss.8                  |   11 
 zconf/lsluns.8                 |    2 
 zconf/lstape                   |   15 
 zconf/lstape.8                 |   15 
 zconf/lszcrypt.8               |    5 
 zconf/znetconf.8               |   60 -
 zdump/zgetdump.c               |   63 +
 zdump/zgetdump.h               |    4 
 zfcpdump/kernel/dump.c         |   91 ++
 zfcpdump/kernel/dump.h         |    8 
 zfcpdump/ramdisk/zfcp_dumper.c |   48 +
 62 files changed, 1238 insertions(+), 1421 deletions(-)

Index: s390-tools-sles11/ipl_tools/system.c
===================================================================
--- s390-tools-sles11.orig/ipl_tools/system.c
+++ s390-tools-sles11/ipl_tools/system.c
@@ -74,7 +74,7 @@ out:
 char *substring(size_t start, size_t stop, const char *src, char *dst,
 		size_t size)
 {
-	int count;
+	unsigned int count;
 
 	count = stop - start;
 	if (count >= --size)
@@ -102,7 +102,7 @@ int check_for_root(void)
 int ishex(char *cp)
 {
 
-	int i;
+	unsigned int i;
 	char c;
 
 	for (i = 0; i <= strlen(cp); i++) {
@@ -168,13 +168,13 @@ int strrd(char *string, char *file)
 
 	strncpy(path, file, sizeof(path));
 	if (access(path, R_OK) == 0) {
-		filp = fopen(path, "r");
+		filp = fopen(path, "rb");
 		if (!filp) {
 			fprintf(stderr,	"%s: Can not open %s: ", name, file);
 			fprintf(stderr, "%s\n", strerror(errno));
 			exit(1);
 		}
-		rc = fscanf(filp, "%s", string);
+		rc = fread(string, 4096, 1, filp);
 		fclose(filp);
 		/*
 		 *  special handling is required for
@@ -192,8 +192,11 @@ int strrd(char *string, char *file)
 					file);
 			fprintf(stderr, "%s\n", strerror(errno));
 			return -1;
-		} else
+		} else {
+			if (string[strlen(string) - 1] == '\n')
+				string[strlen(string) - 1] = 0;
 			return 0;
+		}
 	} else {
 		fprintf(stderr,	"%s: Can not open %s: ", name, file);
 		fprintf(stderr, "%s\n", strerror(errno));
Index: s390-tools-sles11/vmconvert/lkcd_dump.h
===================================================================
--- s390-tools-sles11.orig/vmconvert/lkcd_dump.h
+++ s390-tools-sles11/vmconvert/lkcd_dump.h
@@ -11,6 +11,7 @@
 #define LKCD_DUMP_H
 
 #include "dump.h"
+#include "zt_common.h"
 #include "register_content.h"
 
 
@@ -40,16 +41,15 @@
 
 #define GZIP_NOT_COMPRESSED -1
 
-
 class LKCDDump : public Dump
 {
 public:
 	LKCDDump(Dump*,const char*);
 	virtual ~LKCDDump(void){}
-	inline virtual void readMem(char* buf, int size) {
+	inline virtual void readMem(char* UNUSED(buf), int UNUSED(size)) {
 		throw(DumpException("LKCDDump::readMem() not implemented!"));
 	}
-	inline int seekMem(uint64_t offset){
+	inline int seekMem(uint64_t UNUSED(offset)){
 		throw(DumpException("LKCDDump::seekMem() not implemented!"));
 	}
 	inline virtual uint64_t getMemSize() const
Index: s390-tools-sles11/vmconvert/main.cpp
===================================================================
--- s390-tools-sles11.orig/vmconvert/main.cpp
+++ s390-tools-sles11/vmconvert/main.cpp
@@ -118,7 +118,8 @@ main(int argc, char* argv[])
 	if(stat(outputFileName,&s) == 0){
 		char answer[100];
 		printf("%s: overwrite file '%s'? ",argv[0],outputFileName);
-		scanf("%s",answer);
+		if(scanf("%s",answer) != 1)
+			exit(1);
 		if((strcmp(answer,"y") != 0) && (strcmp(answer,"yes") != 0))
 			exit(0);
 	}
Index: s390-tools-sles11/vmcp/vmcp.c
===================================================================
--- s390-tools-sles11.orig/vmcp/vmcp.c
+++ s390-tools-sles11/vmcp/vmcp.c
@@ -40,8 +40,8 @@ static void print_help(const char *name)
 
 static void print_version(const char *name)
 {
-	printf("%s: z/VM CP command interface version %s.\n"
-	       "Copyright IBM Corp. 2005, 2006.\n",
+	printf("%s: z/VM CP command interface version %s\n"
+	       "Copyright IBM Corp. 2005, 2006\n",
 	       name, RELEASE_STRING);
 }
 
@@ -152,8 +152,10 @@ static ssize_t read_buffer(int fd, char 
 	ssize_t ret;
 	ssize_t done;
 
-	for (done = 0; done < count; done += ret) {
+	for (done = 0; done < (ssize_t) count; done += ret) {
 		ret = read(fd, &buf[done], count - done);
+		if (ret == -1 && errno == EINTR)
+			continue;
 		if (ret == -1)
 			return -1;
 		if (ret == 0)
@@ -169,8 +171,10 @@ static ssize_t write_buffer(int fd, cons
 	ssize_t ret;
 	ssize_t done;
 
-	for (done = 0; done < count; done += ret) {
+	for (done = 0; done < (ssize_t) count; done += ret) {
 		ret = write(fd, &buf[done], count - done);
+		if (ret == -1 && errno == EINTR)
+			continue;
 		if (ret == -1)
 			return -1;
 		if (ret == 0)
Index: s390-tools-sles11/vmur/vmur.cpp
===================================================================
--- s390-tools-sles11.orig/vmur/vmur.cpp
+++ s390-tools-sles11/vmur/vmur.cpp
@@ -985,7 +985,7 @@ static void parse_opts_list(struct vmur 
 /*
  * Parse the command line: Default options
  */
-static void parse_opts_default(struct vmur *info, int argc, char *argv[])
+static void parse_opts_default(int argc, char *argv[])
 {
 	int opt, index;
 	static struct option long_options[] = {
@@ -1050,7 +1050,7 @@ static void parse_opts(struct vmur *info
 		ERR_EXIT("Missing command\n");
 
 	if (set_action(info, argv[1])) {
-		parse_opts_default(info, argc, argv);
+		parse_opts_default(argc, argv);
 		ERR("Unknown command '%s'\n", argv[1]);
 		std_usage_exit();
 	}
@@ -1474,7 +1474,8 @@ int write_vmdump(struct vmur *info, stru
 /*
  * Close VM virtual reader in case of a signal e.g. CTRL-C
 */
-static void ur_receive_sig_handler(int sig, siginfo_t *sip, void *p)
+static void ur_receive_sig_handler(int UNUSED(sig), siginfo_t *UNUSED(sip),
+				   void *UNUSED(p))
 {
 	close_reader(&vmur_info, "HOLD");
 	ERR_EXIT("Operation terminated, spool file received incompletely.\n");
@@ -1723,7 +1724,8 @@ static void rscs_punch_setup(struct vmur
 /*
  * Purge punch file in case of a signal e.g. CTRL-C
  */
-static void ur_write_sig_handler(int sig, siginfo_t *sip, void *p)
+static void ur_write_sig_handler(int UNUSED(sig), siginfo_t *UNUSED(sip),
+				 void *UNUSED(p))
 {
 	close_ur_device_purge(&vmur_info);
 	ERR_EXIT("Operation terminated, no spool file created.\n");
Index: s390-tools-sles11/zdump/zgetdump.c
===================================================================
--- s390-tools-sles11.orig/zdump/zgetdump.c
+++ s390-tools-sles11/zdump/zgetdump.c
@@ -87,10 +87,10 @@ char *usage_note =
 "> zgetdump -h\n";
 
 /* Version info */
-static const char version_text[] = "zgetdump: version "RELEASE_STRING".";
+static const char version_text[] = "zgetdump: version "RELEASE_STRING;
 
 /* Copyright notice */
-static const char copyright_notice[] = "Copyright IBM Corp. 2001, 2008.";
+static const char copyright_notice[] = "Copyright IBM Corp. 2001, 2008";
 
 /* global variables */
 
@@ -296,7 +296,10 @@ enum device_status get_device_from_busid
 		return UNDEFINED; /* device with devno does not exist	*/
 	snprintf(temp_file, PATH_MAX, "%s/online", dev_file);
 	fd = open(temp_file, O_RDONLY);
-	read(fd, buffer, 1);
+	if (read(fd, buffer, 1) == -1) {
+		perror("Could not read online attribute.");
+		exit(1);
+	}
 	close(fd);
 	if (buffer[0] != '1')
 		return OFFLINE;   /* device with devno is not online	*/
@@ -325,7 +328,10 @@ enum device_status get_device_from_busid
 	}
 	snprintf(temp_file, PATH_MAX, "%s/%s/dev", dev_file, direntp->d_name);
 	fd = open(temp_file, O_RDONLY);
-	read(fd, buffer, sizeof(buffer));
+	if (read(fd, buffer, sizeof(buffer)) == -1) {
+		perror("Could not read dev file.");
+		exit(1);
+	}
 	close(fd);
 	if (sscanf(buffer, "%i:%i", &major, &minor) != 2) {
 		fprintf(stderr, "Malformed content of %s: %s\n",
@@ -342,7 +348,7 @@ enum device_status get_device_from_busid
  * - valid magic number in the dump tool
  * - valid dump signature in the dump header
  * and set the volume's signature accordingly */
-int get_mvdump_volume_info(struct disk_info *vol, int vol_nr, off_t offset,
+int get_mvdump_volume_info(struct disk_info *vol, uint32_t vol_nr, off_t offset,
 			   struct mvdump_parm_table *table)
 {
 	int fd, rc;
@@ -459,7 +465,7 @@ int get_mvdump_info(int fd, int block_si
 void print_size_limit_info(uint64_t memory)
 {
 	fprintf(stderr, "Dump size limit: ");
-	if (memory == -1)
+	if (memory == (uint64_t) -1)
 		fprintf(stderr, "none\n");
 	else
 		fprintf(stderr, "%lldMB\n", (unsigned long long) memory /
@@ -471,7 +477,7 @@ void print_mvdump_info(int version, int 
 		       uint64_t memory, int force)
 {
 	int i;
-	
+
 	fprintf(stderr, "'%s' is part of Version %i multi-volume dump,\n"
 		"which is spread along the following DASD volumes:\n",
 		dump_device, version);
@@ -623,7 +629,10 @@ void print_lkcd_header(int fd)
 	dump_header_4_1_t dump_header;
 
 	lseek(fd, 0, SEEK_SET);
-	read(fd, &dump_header, sizeof(dump_header));
+	if (read(fd, &dump_header, sizeof(dump_header)) == -1) {
+		perror("Could not read dump header.");
+		exit(1);
+	}
 	fprintf(stderr, "\nThis is a lkcd dump:\n\n");
 	fprintf(stderr,
 		"Memory start   : 0x%"FMT64"x\n", dump_header.dh_memory_start);
@@ -746,9 +755,10 @@ void write_header()
 /* copy partition containing multi-volume dump data to stdout */
 int mvdump_copy(int fd, uint64_t partsize, uint64_t *totalsize)
 {
-	ssize_t n_read, n_written, count;
+	ssize_t n_read, n_written;
 	uint64_t part_offset;
 	int done = 0;
+	size_t count;
 
 	part_offset = HEADER_SIZE;
 	do {
@@ -862,7 +872,10 @@ int dump_end_times(int fd)
 {
 	int ret;
 
-	read(fd, (char *)&end_marker, sizeof(end_marker));
+	if (read(fd, &end_marker, sizeof(end_marker)) == -1) {
+		perror("Could not read end marker.");
+		exit(1);
+	}
 	s390_tod_to_timeval(end_marker.end_time, &h_time_end);
 	if ((strncmp(end_marker.end_string, "DUMP_END", 8) == 0) &&
 	    ((h_time_end.tv_sec - h_time_begin.tv_sec) >= 0)) {
@@ -884,7 +897,7 @@ int check_and_write_end_marker(int fd)
 			perror("\nwrite failed");
 			return 1;
 		}
-		if (rc < sizeof(end_marker)) {
+		if (rc < (ssize_t) sizeof(end_marker)) {
 			fprintf(stderr, "\nwrite failed: "
 				"No space left on device\n");
 			return 1;
@@ -900,7 +913,7 @@ int check_and_write_end_marker(int fd)
 
 /*	if a tape is part of the dump (not the last)	*/
 /*	it should have and ENDOFVOL marker		*/
-int vol_end(int fd)
+int vol_end(void)
 {
 	int ret;
 
@@ -934,7 +947,7 @@ void tape_forwards(int fd)
 
 /*	put current tape offline	*/
 /*	load & rewind next tape		*/
-void load_next(fd)
+void load_next(int fd)
 {
 	int ret;
 	struct mtop mymtop;
@@ -1009,11 +1022,11 @@ void parse_opts(int argc, char *argv[])
 	/* if devicename has been specified                        */
 
 	if ((option_a_set && !option_i_set) || (optind != argc-1)
-	    || (option_d_set && (option_i_set || option_a_set))) {
+	    || (option_d_set && option_i_set)) {
 		printf(help_text);
 		exit(1);
 
-		
+
 	}
 	strcpy(dump_device, argv[optind]);
 }
@@ -1118,12 +1131,13 @@ out:
 int main(int argc, char *argv[])
 {
 	uint64_t cur_time, size_limit;
-	int vol_count, cur_volnr, fd = -1;
+	int vol_count, fd = -1;
 	int version, dumper_arch, dasd_mv_flag = 0, block_size, rc;
 	int force_specified = 0;
 	enum dump_type d_type;
 	enum devnode_type type;
 	struct disk_info vol[MAX_DUMP_VOLUMES];
+	uint32_t cur_volnr;
 
 	rc = 0;
 	parse_opts(argc, argv);
@@ -1209,7 +1223,7 @@ is_dump_device:
 		rc = mvdump_check_or_copy(vol_count, vol);
 		goto out;
 	}
-	
+
 	if (!option_i_set) {		/* copy the dump to stdout */
 		print_s390_header(d_type);
 		write_header();
@@ -1235,8 +1249,7 @@ is_dump_device:
 
 		if (!check_and_write_end_marker(fd))
 			goto out;
-	}
-	if (option_i_set && !option_a_set) {		/* "-i" option */
+	} else if (!option_a_set) {		/* "-i" option */
 		fprintf(stderr, "\n> \"zgetdump -i\" checks if a dump on "
 			"either\n");
 		fprintf(stderr, "> a dasd volume or single tape is valid.\n");
@@ -1269,7 +1282,7 @@ is_dump_device:
 			goto out;
 		} else
 			fprintf(stderr, "Checking for End of Volume...\n");
-		if (vol_end(fd) != 0) {
+		if (vol_end() != 0) {
 			fprintf(stderr, "End of Volume not found: "
 				"this dump is NOT valid.\n\n");
 			rc = 1;
@@ -1280,9 +1293,7 @@ is_dump_device:
 			fprintf(stderr, "This part of the dump is valid.\n\n");
 			goto out;
 		}
-	}
-
-	if (option_i_set && option_a_set) {	/* "-i -a" option */
+	} else {	/* "-i -a" option */
 		fprintf(stderr, "\n> \"zgetdump -i -a\" checks if a "
 			"multi-volume tape dump is valid.\n");
 		fprintf(stderr, "> Please make sure that all volumes are "
@@ -1303,13 +1314,13 @@ is_dump_device:
 			fprintf(stderr, "Dump End Marker found: "
 				"this dump is valid.\n\n");
 			goto out;
-		} else if (vol_end(fd) != 0) {
+		} else if (vol_end() != 0) {
 			fprintf(stderr, "End of Volume not found: "
 				"this dump is NOT valid.\n\n");
 			rc = 1;
 			goto out;
 		}
-		while (vol_end(fd) == 0) {
+		while (vol_end() == 0) {
 			cur_volnr += 1;
 			fprintf(stderr, "Reached End of Volume %i.\n",
 				header.dh_volnr);
@@ -1334,7 +1345,7 @@ is_dump_device:
 				fprintf(stderr, "Dump End found: "
 					"this dump is valid.\n\n");
 				goto out;
-			} else if (vol_end(fd) != 0) {
+			} else if (vol_end() != 0) {
 				fprintf(stderr, "End of Volume not found: "
 					"this dump is NOT valid.\n\n");
 				rc = 1;
Index: s390-tools-sles11/zdump/zgetdump.h
===================================================================
--- s390-tools-sles11.orig/zdump/zgetdump.h
+++ s390-tools-sles11/zdump/zgetdump.h
@@ -38,7 +38,7 @@ typedef struct _s390_dump_header_s {
 	uint32_t             dh_version;                         /* 0x008 */
 
         /* the size of this header (in case we can't read it) */
-	uint32_t             dh_header_size;                     /* 0x00c */ 
+	uint32_t             dh_header_size;                     /* 0x00c */
 
         /* the level of this dump (just a header?) */
 	uint32_t             dh_dump_level;                      /* 0x010 */
@@ -186,7 +186,7 @@ struct disk_info {
 	dev_t device;
 	enum device_status status;
 	enum device_signature signature;
-	uint64_t start_offset;
+	off_t start_offset;
 	uint64_t part_size;
 	char bus_id[9];
 };
Index: s390-tools-sles11/include/zt_common.h
===================================================================
--- s390-tools-sles11.orig/include/zt_common.h
+++ s390-tools-sles11/include/zt_common.h
@@ -13,6 +13,13 @@
 #define STRINGIFY_1(x)			#x
 #define STRINGIFY(x)			STRINGIFY_1(x)
 
+#ifdef UNUSED
+#elif defined(__GNUC__)
+# define UNUSED(x) UNUSED_ ## x __attribute__((unused))
+#else
+# define UNUSED(x) x
+#endif
+
 #define RELEASE_STRING	STRINGIFY (S390_TOOLS_RELEASE)
 
 #endif /* ZT_COMMON_H */
Index: s390-tools-sles11/zconf/lstape
===================================================================
--- s390-tools-sles11.orig/zconf/lstape
+++ s390-tools-sles11/zconf/lstape
@@ -8,6 +8,7 @@
 # (Designed to work with 2.4 as well.)
 #
 # Author(s): S. Bader <shbader@de.ibm.com>
+#            Frank Munzert <munzert@de.ibm.com>
 #
 # This file is part of s390-tools
 #
@@ -58,11 +59,11 @@ function PrintUsage() {
 	:			subchannel set 0 and remove the leading '0.0.'
 	:			from the displayed bus id (only affects the
 	:			output of CCW devices).
-	:		--verbose
+	:		-V|--verbose
 	:			Print additional information that does not fit
 	:			into a single line (only affects the output for
 	:			SCSI devices).
-	:		--version
+	:		-v|--version
 	:			Display the version of the tools package and
 	:			the lstape command.
 	EOD
@@ -70,11 +71,9 @@ function PrintUsage() {
 
 function PrintVersion()
 {
-	local TVER="1.19"
-
 	cat <<-EOD
-	$CMD: version %S390_TOOLS_VERSION% ($TVER).
-	Copyright IBM Corp. 2003, 2007.
+	$CMD: version %S390_TOOLS_VERSION%
+	Copyright IBM Corp. 2003, 2007
 	EOD
 }
 
@@ -120,11 +119,11 @@ while [ $# -ne 0 ]; do
 		-s|--shortid)
 			SHORTID=true
 			;;
-		--version)
+		-v|--version)
 			PrintVersion
 			exit 0
 			;;
-		--verbose)
+		-V|--verbose)
 			VERBOSE=true;
 			;;
 		--ccw-only)
Index: s390-tools-sles11/tape390/tape390_common.c
===================================================================
--- s390-tools-sles11.orig/tape390/tape390_common.c
+++ s390-tools-sles11/tape390/tape390_common.c
@@ -59,7 +59,8 @@ int is_not_tape(char *device)
 			strcpy(last_line, line);
 	}
 	fclose(fh);
-	if (found && (major(stat_struct.st_rdev) == atoi(last_line)))
+	if (found && (major(stat_struct.st_rdev) ==
+		      (unsigned int) atoi(last_line)))
 		return (0);
 	else {
 		ERRMSG("%s: '%s' is not a tape device. \n", prog_name, device);
Index: s390-tools-sles11/tape390/tape390_crypt.c
===================================================================
--- s390-tools-sles11.orig/tape390/tape390_crypt.c
+++ s390-tools-sles11/tape390/tape390_crypt.c
@@ -137,8 +137,8 @@ static const char copyright_notice[] = "
  */
 static void print_version (void)
 {
-	printf ("%s version %s.\n", tool_name, RELEASE_STRING);
-	printf ("%s.\n", copyright_notice);
+	printf ("%s version %s\n", tool_name, RELEASE_STRING);
+	printf ("%s\n", copyright_notice);
 }
 
 /*
@@ -308,7 +308,7 @@ static void fill_kekl(char *s, char deli
 		ERRMSG_EXIT(EXIT_MISUSE,
 			    "%s: ERROR: delimiter '%c' found as first "
 			    "character.\n",prog_name,delimiter);
-	else if (i == strlen(s) - 1)
+	else if (i == (int) strlen(s) - 1)
 		ERRMSG_EXIT(EXIT_MISUSE,
 			    "%s: ERROR: Delimiter '%c' found as last "
 			    "character.\n",prog_name,delimiter);
@@ -416,7 +416,10 @@ static int set_encryption_keys(int fd, s
 		printf("--->> ATTENTION! <<---\n");
 		printf("All data on tape %s will be lost.\nType "
 		       "\"yes\" to continue: ", info->devname);
-		fgets(inp_buffer, sizeof(inp_buffer), stdin);
+		if (fgets(inp_buffer, sizeof(inp_buffer), stdin) == NULL) {
+			fprintf(stderr, "Reading from terminal failed.\n");
+			exit(1);
+		}
 		if (strcasecmp(inp_buffer,"yes\n")) {
 			printf("Tape and its encryption keys " 
 			       "remain unchanged.\n");
@@ -434,8 +437,9 @@ static int set_encryption_keys(int fd, s
  */
 static int switch_encryption_on_or_off(int fd,struct tape390_crypt *info)
 {
-	struct tape390_crypt_info myinfo = {0};
+	struct tape390_crypt_info myinfo;
 
+	memset(&myinfo, 0, sizeof(myinfo));
 	if (info->e_switch == ENCRYPTION_ON)
 		myinfo.status |= TAPE390_CRYPT_ON_MASK;
 	return ioctl(fd, TAPE390_CRYPT_SET, &myinfo);
@@ -479,8 +483,6 @@ static int query_encryption(int fd,struc
 	ret = ioctl(fd, TAPE390_KEKL_QUERY, &kekls);
 	if (ret)
 		return -2;
-	if (!TAPE390_MEDIUM_ENCRYPTED(myinfo))
-		return 0;
 	printf("KEKLs on TAPE:\n");
 	if (kekls.kekl[0].type == TAPE390_KEKL_TYPE_NONE) {
 		ERRMSG("Unable to retrieve key information.\n");
Index: s390-tools-sles11/tape390/tape390_display.c
===================================================================
--- s390-tools-sles11.orig/tape390/tape390_display.c
+++ s390-tools-sles11/tape390/tape390_display.c
@@ -197,9 +197,9 @@ int main(int argc, char *argv[]) {
 			}
 			case 'v': {
 				printf("tape390_display: zSeries tape "
-				       "display control program version %s.\n",
+				       "display control program version %s\n",
 					RELEASE_STRING);
-				printf("Copyright IBM Corp. 2002, 2006.\n");
+				printf("Copyright IBM Corp. 2002, 2006\n");
 				exit(0);
 			}
 			default:
Index: s390-tools-sles11/mon_tools/mon_fsstatd.c
===================================================================
--- s390-tools-sles11.orig/mon_tools/mon_fsstatd.c
+++ s390-tools-sles11/mon_tools/mon_fsstatd.c
@@ -43,7 +43,7 @@ struct mw_name_lens {
 /*
  * Clean up when SIGTERM or SIGINT received
  */
-void stop_fsstatd(int a)
+void stop_fsstatd(int UNUSED(a))
 {
 	remove(pid_file);
 	exit(0);
@@ -370,9 +370,8 @@ static int parse_options(int argc, char 
 			printf("%s", help_text);
 			exit(0);
 		case 'v':
-			printf("mon_fsstatd: version %s (%s)\n",
-				RELEASE_STRING, FSSTATD_VERSION);
-			printf("Copyright IBM Corp. 2006.\n");
+			printf("mon_fsstatd: version %s\n", RELEASE_STRING);
+			printf("Copyright IBM Corp. 2006\n");
 			exit(0);
 		case 'a':
 			attach = 1;
Index: s390-tools-sles11/mon_tools/mon_fsstatd.h
===================================================================
--- s390-tools-sles11.orig/mon_tools/mon_fsstatd.h
+++ s390-tools-sles11/mon_tools/mon_fsstatd.h
@@ -16,8 +16,6 @@
 #include <sys/ioctl.h>
 #include "../include/zt_common.h"
 
-#define FSSTATD_VERSION "1.0.0"
-
 /* mon_function values */
 #define MONWRITE_START_INTERVAL 0x00	/* start interval recording */
 #define MONWRITE_STOP_INTERVAL	0x01	/* stop interval or config recording */
Index: s390-tools-sles11/mon_tools/mon_procd.c
===================================================================
--- s390-tools-sles11.orig/mon_tools/mon_procd.c
+++ s390-tools-sles11/mon_tools/mon_procd.c
@@ -41,7 +41,7 @@ struct name_lens_t {
 static int num_cpus;
 static int curr_small_max, curr_big_max;
 static int prev_small_max, prev_big_max;
-static int pg_to_kb_shift, sort_tbl_size;
+static unsigned int pg_to_kb_shift, sort_tbl_size;
 static float e_time;
 static struct timeval prev_time, curr_time;
 static struct cpudata_t cpudata;
@@ -62,7 +62,7 @@ static const char *pid_file = "/var/run/
 /*
  * Clean up when SIGTERM or SIGINT received
  */
-void stop_procd(int a)
+void stop_procd(int UNUSED(a))
 {
 	remove(pid_file);
 	exit(0);
@@ -505,7 +505,7 @@ static int read_status(struct task_t *ta
 */
 static void cal_task_pcpu(struct task_t *task, const unsigned long long tics)
 {
-	int i, size;
+	unsigned int i, size;
 	__u64 etics;
 
 	if (proc_sum.task.total + 1 >= sort_tbl_size) {
@@ -794,7 +794,7 @@ static void task_usage(struct task_t *ta
 static void read_tasks(void)
 {
 	int size;
-	int i = 0, j = 0;
+	unsigned int i = 0, j = 0;
 	DIR *proc_dir;
 	struct direct *entry;
 	struct task_t task;
@@ -952,9 +952,8 @@ static int parse_options(int argc, char 
 			printf("%s", help_text);
 			exit(0);
 		case 'v':
-			printf( "mon_procd: version %s (%s)\n",
-				RELEASE_STRING, PROCD_VERSION);
-			printf("Copyright IBM Corp. 2007.\n");
+			printf( "mon_procd: version %s\n", RELEASE_STRING);
+			printf("Copyright IBM Corp. 2007\n");
 			exit(0);
 		case 'a':
 			attach = 1;
Index: s390-tools-sles11/mon_tools/mon_procd.h
===================================================================
--- s390-tools-sles11.orig/mon_tools/mon_procd.h
+++ s390-tools-sles11/mon_tools/mon_procd.h
@@ -14,8 +14,6 @@
 #include <linux/types.h>
 #include "../include/zt_common.h"
 
-#define PROCD_VERSION "1.0.0"
-
 /* mon_function values */
 #define MONWRITE_START_INTERVAL 0x00	/* start interval recording */
 #define MONWRITE_STOP_INTERVAL	0x01	/* stop interval or config recording */
Index: s390-tools-sles11/libu2s/u2s.c
===================================================================
--- s390-tools-sles11.orig/libu2s/u2s.c
+++ s390-tools-sles11/libu2s/u2s.c
@@ -56,7 +56,8 @@ static int check_directory(char *name, c
 	char *end;
 	int fd;
 	ssize_t count;
-	int dev_attr_len, dev_parm_len, namelen;
+	int dev_attr_len, dev_parm_len;
+	unsigned int namelen;
 
 	namelen = strlen(name);
 	if ((PATH_BUFFER_LENGTH - namelen) < sizeof(DEV_ATTRIBUTE))
@@ -90,7 +91,8 @@ static int check_directory(char *name, c
  */
 static int extract_busid(char *name, char *busid) {
 
-	int count, namelen;
+	int count;
+	unsigned int namelen;
 	char linkbuffer[PATH_BUFFER_LENGTH];
 	char *start, *end;
 
Index: s390-tools-sles11/scripts/dbginfo.sh
===================================================================
--- s390-tools-sles11.orig/scripts/dbginfo.sh
+++ s390-tools-sles11/scripts/dbginfo.sh
@@ -21,6 +21,7 @@ WORKPATH=$WORKPFX/$WORKDIR
 CMDOUTPUT=runtime.out
 VM_CMDOUTPUT=zvm_runtime.out
 SYSFSFILELIST=sysfsfiles.out
+FCPCONFOUTPUT=scsi
 MOUNT_POINT_DEBUGFS="/sys/kernel/debug"
 kernel_version_tmp=0
 
@@ -76,7 +77,7 @@ CONFIGFILES=" \
     /etc/ccwgroup.conf \
     /etc/chandev.conf \
     /etc/modules.conf \
-    /etc/modprobe.conf
+    /etc/modprobe.conf* \ 
     /etc/fstab \
     /etc/syslog.conf \
     /etc/sysconfig \
@@ -93,6 +94,11 @@ CONFIGFILES=" \
     /etc/zfcp.conf \
     "
 
+#sysfs files NOT to be collected
+SYSFSFILEEXCLUDES="\
+	trace_pipe\
+	"
+
 # collect output of following commands;
 # commands are separated by ':'
 CMDS="uname -a\
@@ -113,12 +119,14 @@ CMDS="uname -a\
     :dmsetup ls\
     :dmsetup ls --tree\
     :dmsetup table\
+    :dmsetup table --target multipath\
     :dmsetup status\
     :multipath -v6 -ll\
-    :multipath -d\	
+    :multipath -d\
     :lsqeth\
     :lscss\
     :lsdasd\
+    :ziorep_config -ADM\
     :lsmod\
     :lsdev\
     :lsscsi\
@@ -194,8 +202,8 @@ VM_CMDS="q userid\
 printversion()
 {
     cat <<EOF
-$SCRIPTNAME: Debug information script version %S390_TOOLS_VERSION%.
-Copyright IBM Corp. 2002, 2006.
+$SCRIPTNAME: Debug information script version %S390_TOOLS_VERSION%
+Copyright IBM Corp. 2002, 2006
 EOF
 }
 
@@ -256,7 +264,19 @@ collect_file_contents()
 # append output of command $1 to file $2
 collect_cmd_output()
 {
+    local raw_cmd=`echo $1 | awk '{ print $1 }'`;
+
     echo "#######################################################">>$2
+
+    # check if command exists
+    which $raw_cmd >/dev/null 2>&1;
+    if [ $? -ne 0 ]
+    then
+        # check if command is a builtin
+        command -v $raw_cmd >/dev/null;
+        [ $? -ne 0 ] && echo "command '$raw_cmd' not available">>$2 && return 1;
+    fi
+
     echo "$USER@$HOST> $1">>$2
     $1 1>>$2 2>&1
     echo "" >>$2
@@ -362,6 +382,19 @@ collect_procfs_scsi()
     fi
 }
 
+#check for excluded files in sysfs
+check_for_excludes()
+{
+	for filename in ${SYSFSFILEEXCLUDES[@]}
+	do
+		if [ `basename $1` = $filename ]
+		then
+			return 1
+		fi
+	done
+	return 0
+}
+
 # collect sysfs entries
 collect_sysfs()
 {
@@ -380,8 +413,11 @@ collect_sysfs()
     for i in `find /sys -noleaf -type f -perm +444`
     	do
     		if [ -e $i ]
-    		then
-	    		collect_file_contents $i
+		then
+			if check_for_excludes $i
+			then
+		    		collect_file_contents $i
+			fi
 		else
 			echo "  WARNING: $i not found" | tee -a $LOGFILE
     		fi
@@ -448,8 +484,17 @@ check_zvm()
 	which vmcp > /dev/null 2>&1
     	if [ $? -eq 1 ] 
     	then
-		echo " No cp tool installed" | tee -a $LOGFILE
-		return 0
+		# is hcp installed
+		which hcp > /dev/null 2>&1
+		if [ $? -eq 1 ]
+ 		then
+			echo " No cp tool installed" | tee -a $LOGFILE 
+			return 0
+		else
+			cp_tool=hcp
+			echo " Installed CP tool: $cp_tool" | tee -a $LOGFILE 
+			return 1
+		fi
 	else
 		cp_tool=vmcp
 		echo " Installed CP tool: $cp_tool" | tee -a $LOGFILE 
@@ -464,15 +509,31 @@ get_zvm_data()
 	lsmod | grep -q $cp_tool
 	rc_lsmod=$?
    	if [ $rc_lsmod -eq 1 ]; then
-		modprobe $cp_tool
-		sleep 2
+                if [ $cp_tool = "hcp" ]; then
+                        modprobe cpint
+                        sleep 2
+                else
+                        modprobe $cp_tool
+                        sleep 2
+                fi
         fi
         collect_cmdsout "$VM_CMDS" "$VM_CMDOUTPUT"
         if [ $rc_lsmod -eq 1 ]; then
-		rmmod $cp_tool
+                if [ $cp_tool = "hcp" ]; then
+                        rmmod cpint
+                else
+                        rmmod $cp_tool
+                fi
         fi
 }
 
+# Caputure FCP configuration data if possible
+get_fcp_data()
+{
+    which ziomon_fcpconf >/dev/null 2>&1;
+    [ $? -eq 0 ] && ziomon_fcpconf -o $FCPCONFOUTPUT;
+}
+
 # log files
 collect_log()
 {
@@ -487,16 +548,30 @@ collect_log()
 create_package()
 {
     cd $WORKPATH/..
-    tar -czf $WORKDIR.tgz $WORKDIR 2>/dev/null && rm -rf $WORKPATH
+    tar -czf $WORKDIR.tgz $WORKDIR 2>/dev/null
+    cleanup;
     echo
     echo "Collected data was saved to:"
     echo "  $WORKPFX/$WORKDIR.tgz"
 }
 
+cleanup()
+{
+    [ -d $WORKPATH ] && rm -rf $WORKPATH;
+}
+
+emergency_exit()
+{
+    cleanup;
+    exit;
+}
+
 #
 # start of script
 #
 
+trap emergency_exit SIGHUP SIGTERM SIGINT
+
 kernel_version=`uname -r`
 kernel_version_tmp=`echo ${kernel_version:4:2} | sed s/[^0-9]//g`
 check_cmdline $*
@@ -520,6 +595,7 @@ rc_check_zvm=$?
 if [ $rc_check_zvm -eq 1 ]; then
 	get_zvm_data
 fi
+get_fcp_data
 collect_config
 collect_log
 create_package
Index: s390-tools-sles11/dasdinfo/dasdinfo.c
===================================================================
--- s390-tools-sles11.orig/dasdinfo/dasdinfo.c
+++ s390-tools-sles11/dasdinfo/dasdinfo.c
@@ -108,8 +108,8 @@ struct dasd_data
 
 static void dinfo_print_version (void)
 {
-	printf ("%s version %s.\n", tool_name, RELEASE_STRING);
-	printf ("%s.\n", copyright_notice);
+	printf ("%s version %s\n", tool_name, RELEASE_STRING);
+	printf ("%s\n", copyright_notice);
 }
 
 static void dinfo_print_usage(char *cmd)
